
#include <tmstdlib.h>
#include <vdi.h>
#include <aes.h>
#include <cpxdata.h>
#include <tos.h>
#include "eyes.h"
#include "eyes-rsc.h"

extern WORD eyes_w,eyes_h;
extern OBJECT *eyes;

WORD vh = 0;
static WORD nplanes;
#define wordwidth ((eyes_w + 15)/16)
#define FELD_H (eyes[0].ob_height)
static void* vdibuf;
static void* boxpat;

WORD InitVdi(void)
{
	WORD work_in[11],work_out[57],a;
	LONG i;
	WORD *p;
	
	vh = graf_handle(&a,&a,&a,&a);
	vdibuf = NULL;
	for ( i = 0; i < 10; work_in[i++] = 1 );
	work_in[10] = 2;
	v_opnvwk(work_in,&vh,work_out);
	if ( !vh )
		return 0;
	vq_extnd(vh,1,work_out);
	nplanes = work_out[4];
	if ( nplanes > 0 )
		vdibuf = Malloc( (LONG)wordwidth * 2L * (LONG)FELD_H * (LONG)(nplanes + 1) + 256L );
	if ( vdibuf == NULL )
		return 0;
	boxpat = (void*)((LONG)vdibuf + (LONG)wordwidth * 2L * (LONG)FELD_H * (LONG)nplanes);
	for ( p = boxpat, i = 0; i < (LONG)wordwidth * (LONG)FELD_H; i++ )
		*p++ = 0xffff;
	vst_height(vh,4,&a,&a,&a,&a);
	vst_alignment(vh,TA_CENTER,TA_TOP,&a,&a);
	vswr_mode(vh,MD_TRANS);
	return 1;
}

void DeinitVdi(void)
{
	if ( vdibuf )
	{	Mfree(vdibuf); vdibuf = NULL; }
	if ( vh )
	{	v_clsvwk(vh); vh = 0; }
}

void blitdraw(GRECT *pos,GRECT *clip)
{
	MFDB src,dst;
	WORD p[8];
	
	if ( (src.fd_addr = vdibuf) == NULL )
		return;
	src.fd_w = eyes_w;
	src.fd_h = FELD_H;
	src.fd_wdwidth = wordwidth;
	src.fd_stand = 0;
	src.fd_nplanes = nplanes;
	src.fd_r1 = src.fd_r2 = src.fd_r3 = 0;
	
	dst.fd_addr = NULL;
	
	p[0] = clip->g_x;
	p[1] = clip->g_y;
	p[2] = clip->g_x + clip->g_w - 1;
	p[3] = clip->g_y + clip->g_h - 1;
	vs_clip(vh,1,p);
	
	p[0] = p[1] = 0;
	p[2] = eyes_w - 1;
	p[3] = FELD_H - 1;
	p[4] = pos->g_x;
	p[5] = pos->g_y;
	p[6] = pos->g_x + pos->g_w - 1;
	p[7] = pos->g_y + pos->g_h - 1;
	
	vro_cpyfm(vh,3,p,&src,&dst);
	
	vst_color(vh,(eyes[OMAUSPOS].ob_spec.tedinfo->te_color & 0x0f00) >> 8);
	v_gtext(vh,pos->g_x + (UWORD)eyes_w / 2,pos->g_y + eyes_h + 2,
			eyes[OMAUSPOS].ob_spec.tedinfo->te_ptext);

}


static void blit(WORD relx,WORD rely,WORD w, WORD h, void *img,
				 WORD imgw, WORD imgh, WORD col)
{
	MFDB src,dst;
	WORD p[8], color[2];
	
	color[0] = col;
	color[1] = 0;
	
	src.fd_addr = img;
	src.fd_w = imgw;
	src.fd_h = imgh;
	src.fd_wdwidth = (imgw + 15)>>4;
	src.fd_stand = 1;
	src.fd_nplanes = 1;
	src.fd_r1 = src.fd_r2 = src.fd_r3 = 0;
	
	dst.fd_addr = vdibuf;
	dst.fd_w = eyes_w;
	dst.fd_h = FELD_H;
	dst.fd_wdwidth = wordwidth;
	dst.fd_stand = 0;
	dst.fd_nplanes = nplanes;
	dst.fd_r1 = dst.fd_r2 = dst.fd_r3 = 0;
	
	p[0] = p[1] = 0;
	p[2] = w - 1;
	p[3] = h - 1;
	p[4] = relx;
	p[5] = rely;
	p[6] = relx + w - 1;
	p[7] = rely + h - 1;
	
	vrt_cpyfm(vh,2,p,&src,&dst,color);
}

static void _paste(WORD parent,WORD relx,WORD rely)
{
	extern OBJECT *eyes;
	register OBJECT *o;
	register WORD obj,x,y;
	
	obj = eyes[parent].ob_head;
	do
	{	o = &eyes[obj];
		if ( ! (o->ob_flags & HIDETREE ) )
		{	x = relx + o->ob_x;
			y = rely + o->ob_y;
			switch ( o->ob_type & 0xff )
			{
			 case G_IMAGE:
			 		{	register BITBLK *b = o->ob_spec.bitblk;
						blit(x,y,b->bi_wb*8,b->bi_hl,
							 b->bi_pdata,b->bi_wb*8,b->bi_hl,
							 b->bi_color);
						break;
					}	 
		 
			 case G_ICON:
			 		{	register ICONBLK *i = o->ob_spec.iconblk;
			 			blit(x,y,i->ib_wicon,i->ib_hicon,
			 				 i->ib_pmask,i->ib_wicon,i->ib_hicon,
			 				 (i->ib_char >> 8) & 0xf);
			 			blit(x,y,i->ib_wicon,i->ib_hicon,
			 				 i->ib_pdata,i->ib_wicon,i->ib_hicon,
			 				 (i->ib_char >> 12) & 0xf);
			 			break;
			 		}
			 		
			 case G_BOX:
			 		blit(x,y,o->ob_width,o->ob_height,boxpat,
			 			 eyes_w,FELD_H,o->ob_spec.index & 0xf);
			 		break;
			 
			 case G_BOXTEXT:
			 		blit(x,y,o->ob_width,o->ob_height,boxpat,
			 				eyes_w,FELD_H,o->ob_spec.tedinfo->te_color & 0xf);
					break;
			}
			if ( o->ob_head > 0 )
				_paste(obj,x,y);
		}
		obj = o->ob_next;
	} while ( obj != parent );
}

void paste_image(void)
{
	if (vh && vdibuf)
	{	blit(0,0,eyes[ROOT].ob_width,eyes[ROOT].ob_height,boxpat,
				 eyes_w,FELD_H,eyes[ROOT].ob_spec.index & 0xf);
		_paste(ROOT,0,0);
	}	
}


void get_farbanzahl(void)
{
	extern WORD anzcol,numcol;

	if ( vh )
	{	if ( vsl_color(vh,15) == 15 )
			anzcol = 16, numcol = 2;
		else if ( vsl_color(vh,3) == 3 )
			anzcol = 4, numcol = 1;
		else
			anzcol = 2, numcol = 0;
	}
	else anzcol = 2, numcol = 0;
}



void set_evnt_mask(void)
{	static MOBLK dummymoblk;
	cpxSet_Evnt_Mask(xcpb,MU_TIMER|MU_BUTTON|MU_KEYBD,
					&dummymoblk,&dummymoblk,saveblk->time);
}

void save_defaults(void)
{
	if ( cpxXGen_Alert(xcpb,SAVE_DEFAULTS) )
		cpxCPX_Save(xcpb,(void*)saveblk,sizeof(*saveblk));
}


/* Berechnet Augenposition */

#define XA 7
#define YB 11

void calc( WORD dx, WORD dy, WORD *px, WORD *py )
{
	WORD a,b;
	WORD phi;
	LONG c;
	
	if ( dx == 0 )
	{	*px = 0;
		if ( dy < 0 )
			*py = ( dy > -YB ? dy : -YB );
		else
			*py = ( dy > YB ? YB : dy );
		return;
	}
	
	if ( (LONG)dx * dx + (LONG)dy * dy <= XA * XA )
	{	*px = dx; /* Naeherungsweise */
		*py = dy;
		return;
	}
	
	/* Winkel berechnen */
	a = (dx > 0 ? dx : -dx);
	c = (dy > 0 ? dy : -dy);
	c = (c * MATHOFFSET) / (LONG)a;
	for ( phi = 0; phi < TANTABMAX; phi++ )
		if ( c < (LONG)tantab[phi] ) break;
	
	b = ((LONG)sintab[phi] * YB) / MATHOFFSET;
	a = ((LONG)sintab[90-phi] * XA) / MATHOFFSET;
	
	if ( dx < 0 )
		a = -a;
	if ( dy < 0 )
		b = -b;
	
	*px = a;
	*py = b;
}


/* Wandelt WORD in ASCII */
char *w2a( char *buf, WORD w)
{
	char b[6], *p = b;
	
	do
	{
		*p++ = (char)(w % 10) + '0';
	} while ( w /= 10 );
	while ( p > b )
		*buf++ = *(--p);

	*buf = 0;	
	return buf;
}	



WORD cram = 0;
void *ram = NULL;

void InitRam(void)
{
	if ( cpxgetcookie(xcpb,asc2long('M','i','N','T'),NULL)
			|| cpxgetcookie(xcpb,asc2long('M','a','g','X'),NULL) )
		ram = Mxalloc(RAMSIZE,0x20+3);
	else
		ram = Malloc(RAMSIZE);
}

void FreeRam(void)
{	if ( ram )
	{	Mfree(ram); ram = NULL; }
}

